package org.dromara.mall.promotion.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.mall.promotion.domain.MallPromotion;
import org.dromara.mall.promotion.domain.bo.MallPromotionBo;
import org.dromara.mall.promotion.domain.vo.MallPromotionVo;

import java.util.Collection;
import java.util.List;

/**
 * 营销活动Service接口
 *
 * @author pengles
 */
public interface MallPromotionService extends IService<MallPromotion> {

    /**
     * 查询营销活动
     */
    MallPromotionVo queryById(Long id);

    /**
     * 查询营销活动列表
     */
    TableDataInfo<MallPromotionVo> queryPageList(MallPromotionBo bo, PageQuery pageQuery);

    /**
     * 查询营销活动列表
     */
    List<MallPromotionVo> queryList(MallPromotionBo bo);

    /**
     * 新增营销活动
     */
    Boolean insertByBo(MallPromotionBo bo);

    /**
     * 修改营销活动
     */
    Boolean updateByBo(MallPromotionBo bo);

    /**
     * 校验并批量删除营销活动信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 启用/禁用营销活动
     */
    Boolean changeStatus(Long id, Integer status);

    /**
     * 根据活动类型查询活动列表
     */
    List<MallPromotionVo> queryListByType(Integer type);

}
